http:
  routers:
{% for host in hosts_to_proxy %}
    {{ host.name }}-http:
      entryPoints:
        - "http"
      rule: "Host(`{{ host.host }}`)"
      middlewares:
        - https-redirect
      service: {{ host.name }}
{% endfor %}
{% for host in hosts_to_proxy %}
    {{ host.name }}-https:
      entryPoints:
        - "https"
      rule: "Host(`{{ host.host }}`)"
      middlewares:
{% for middleware in host.middlewares %}
        - {{ middleware }}
{% endfor %}
      tls: {}
      service: {{ host.name }}
{% endfor %}

  services:
{% for host in hosts_to_proxy %}
    {{ host.name }}:
      loadBalancer:
        servers:
          - url: "{{ host.url }}"
        passHostHeader: true
{% endfor %}

  middlewares:
    https-redirect:
      redirectScheme:
        scheme: https
        permanent: true

    default-headers:
      headers:
        frameDeny: true
        sslRedirect: true
        browserXssFilter: true
        contentTypeNosniff: true
        forceSTSHeader: true
        stsIncludeSubdomains: true
        stsPreload: true
        stsSeconds: 15552000
        customFrameOptionsValue: SAMEORIGIN
        customRequestHeaders:
          X-Forwarded-Proto: https

    default-whitelist:
      ipWhiteList:
        sourceRange:
        - "10.0.0.0/8"
        - "192.168.0.0/16"
        - "172.16.0.0/12"

    secured:
      chain:
        middlewares:
        - default-whitelist
        - default-headers
